﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace NoEmptyLinesExample
{
    public partial class Form1 : Form
    {
        private Thread thread;

        public Form1()
        {
            InitializeComponent();

            this.thread = new Thread(new ThreadStart(ThreadMethod));
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            this.AddText();
        }

        private void radTextBox1_TextChanged(object sender, EventArgs e)
        {
            this.radTextBox1.TextChanged -= radTextBox1_TextChanged;
            ClearEmptyLines();
            this.radSpinEditor1.Value = this.radTextBox1.Lines.Length;
            this.radTextBox1.TextChanged += radTextBox1_TextChanged;
        }

        private void AddText()
        {
            this.radTextBox1.Text += Environment.NewLine + "Line";
        }

        private void ThreadMethod()
        {
            for (int i = 0; i < 5; i++)
            {
                System.Threading.Thread.Sleep(2000);
                this.Invoke(new MethodInvoker(AddText));
            }
        }

        private void radButton2_Click(object sender, EventArgs e)
        {
            this.thread.Start();
        }

        private void ClearEmptyLines()
        {
            List<string> notEmptyLines = new List<string>();

            foreach (string line in this.radTextBox1.Lines)
            {
                if (!String.IsNullOrEmpty(line))
                {
                    notEmptyLines.Add(line);
                }
            }

            this.radTextBox1.Lines = notEmptyLines.ToArray();
        }

        private void radTextBox1_Enter(object sender, EventArgs e)
        {
            this.radTextBox1.TextChanged -= radTextBox1_TextChanged;
        }

        private void radTextBox1_Leave(object sender, EventArgs e)
        {
            ClearEmptyLines();
            this.radTextBox1.TextChanged += radTextBox1_TextChanged;
        }
    }
}
